      PROGRAM CPA
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /A/ RR(50,9,9),RI(50,9,9),XR(50,9,9),XI(50,9,9)
      COMMON/B/QQ,WEIGHT,TOTVOL,NS
      DIMENSION R(9,9),WK(110)
C     DIMENSION RR(50,9,9),RI(50,9,9),XR(50,9,9),XI(50,9,9)
      DIMENSION H(9,9),UPARM(60),X(9,9),V(9)
      DIMENSION A(20)
      DIMENSION AR( 5300),AI( 5300),HMZ(9,9, 5300),VST(9, 5300)
      DIMENSION HHYD( 5300)
      DIMENSION WEIGHT( 5300),QQ (5300,3)
      DIMENSION DUM(4000),EDUM(4000),ANUMEL(4000)
      DIMENSION RES(8,4000)
      DIMENSION        DUMM(4000), DUMP2(4000),DUMS2(4000)
      DIMENSION DUMS1(4000),DUMP1(4000),DUMD1(4000),DUMD2(4000)
      DIMENSION DENSFL(6),PAR(60)
      REAL*8 INTERP
      REAL*8 NUELEC
      OPEN(5,FILE='cpa.in',BLANK='ZERO')
      OPEN(6,FILE='cpa.out',BLANK='ZERO')
      OPEN(20,FILE='cpa.dos',BLANK='ZERO') 
      PI=3.141593
      NEN=4000
 1000 FORMAT (3I5,F10.5)
 1001 FORMAT(8F10.4)
 1002 FORMAT(I5,3F10.5)
 1003 FORMAT(6D15.5)
 2002 FORMAT(20A4)
 9000 FORMAT(1H1)
      READ(5,2002) (A(I),I=1,20)
      READ(5,1000) NPARM,NDIM,NKS,NUELEC
      WRITE(6,1000) NPARM,NDIM,NKS,NUELEC
      DO 8600 J=1,NPARM
      READ(5,1040) UPARM(J),NNP
 1040 FORMAT(F13.10,4X,I3)
      WRITE(6,1006) UPARM(J),NNP
 1006 FORMAT(10X,F15.8,I10)
      IF(NNP.EQ.J) GO TO 8600
      WRITE(6,1045)
 1045 FORMAT(//10X,37H PARAMETERS OUT OF ORDER --- STOPPING)
      STOP
 8600 CONTINUE
      DO 555 I=1,NEN
 555  ANUMEL(I)=0.0
c   This allows for reading a second set of TB parameters for another hydride
c   and then average them to treat a ternary in the virtual crystal approximation. 
c     DO 8601 J=1,NPARM
c     READ(5,1040) PAR(J),NNP
c     WRITE(6,1006) PAR(J),NNP
c     IF(NNP.EQ.J) GO TO 8601
c     WRITE(6,1045)
c     STOP
 8601 CONTINUE
      CALL BZONE(NKS)
 9623 CONTINUE
      READ(5,1001) CB,EMIN,EMAX,DELE,EPIV,SAGR,SAGI,CONV
c     DO 8602 J=1,NPARM
c8602 UPARM(J)=(1.0-CB)*UPARM(J)+CB*PAR(J)
      WRITE(6,9000)
      WRITE(6,2002) (A(I),I=1,20)
      WRITE(6,1005) (UPARM(I),I=1,NPARM)
 1005 FORMAT(10X,F15.8)
      WRITE(6,1001) CB,EMIN,EMAX,DELE,EPIV,SAGR,SAGI
      READ(5,500) EPS,SKIP
  500 FORMAT(2F15.8)
      WRITE(6,600) EPS
  600 FORMAT (///50X,' EPS= ',F15.8)
      EH=UPARM(33)
      E=EMIN
      DO 19  I=1,NS
      XK1=QQ(I,1)
      XK2=QQ(I,2)
      XK3=QQ(I,3)
      CALL MATS(XK1,XK2,XK3,H,UPARM,V,NDIM,HYD)
      DO 19  K=1,NDIM
      VST(K,I)= V(K)
      DO 19  L=1,NDIM
      HMZ (K,L,I)= H(K,L)
      HHYD(I)= HYD
   19 CONTINUE
      N50= NS/50 + 1
      M50= 50*(N50 - 1)
      DO9999IXYZ=1,NEN
C     ITIME=ICLOCK(DUM)
      DO 810  I1=1,N50
      J50= (I1-1)*50
      I50= 50
      IF((I1*50).GT.NS) I50= NS - M50
      IF(I50.LE.0) GO TO 810
      DO 820  I2=1,I50
      I= J50 + I2
      DO7K=1,NDIM
      DO7L=1,NDIM
      H(K,L)=  HMZ(K,L,I)
      IF(K.EQ.L)GOTO79
      RR(I2,K,L)= H(K,L)
      RI(I2,K,L)= 0.0
      XR(I2,K,L)= 0.0
      XI(I2,K,L)= 0.0
      GOTO7
   79  RR(I2,K,K)= H(K,K) - E
      RI(I2,K,K)= - EPS
      XR(I2,K,K)= 1.0
      XI(I2,K,K)= 0.0
 7    CONTINUE
  820 CONTINUE
       CALL CLSS(9,9,9,9,I50)
C     CALL CLSS(9,9,RR,RI,9,XR,XI,9,I50)
      DO 9  I2=1,I50
      I= J50 + I2
      QR= 0.0
      QI= 0.0
      DO77K=1,NDIM
      DO77L=1,NDIM
      QR= QR + VST(K,I)*XR(I2,K,L)*VST(L,I)
      QI= QI + VST(K,I)*XI(I2,K,L)*VST(L,I)
   77 CONTINUE
      C= QR
      D= QI
      AR(I)= E + C - HHYD(I)
      AI(I)=EPS+D
 9    CONTINUE
  810 CONTINUE
      SIGR= SAGR
      SIGI= SAGI
      CHKR= SIGR
      CHKI= SIGI
      DO999N=1,500
      GR= 0.0
      GI= 0.0
      MCHK=0
      DO99I=1,NS
      W=AR(I)-SIGR
       Y=AI(I)-SIGI
      DEN=W*W+Y*Y
      GR = GR + W*WEIGHT(I)/DEN
      GI= GI - Y*WEIGHT(I)/DEN
 99   CONTINUE
      GR= GR/TOTVOL
      GI= GI/TOTVOL
      GDEN= GR*GR + GI*GI
      SIGR= EH - GR*CB/GDEN
      SIGI= CB*GI/GDEN
      IF(( ABS(SIGR-CHKR).LT.CONV   ).AND.( ABS(SIGI-CHKI).LT.CONV   ))
     1MCHK=1
      CHKR= SIGR
      CHKI= SIGI
      IF(MCHK.EQ.1)GOTO9991
 999  CONTINUE
      PRINT1004,E
 1004 FORMAT('   SIGMA DIDN T CONVERGE FOR E=',F10.4)
      GOTO9999
 9991 CONTINUE
      PRINT1002,N,SIGR,SIGI
C     EL=DCMPLX(E,EPS)-SIG
      ELR= E - SIGR
      ELI= EPS - SIGI
      ELMAG= ELR**2 + ELI**2
      ELRMAG= ELR/ELMAG
      ELIMAG= ELI/ELMAG
      GGI= 0.0
      PDS= 0.0
      PDP= 0.0
      PDD1=0.0
      PDD2=0.0
      DO 860  I1=1,N50
      J50= (I1-1)*50
      I50= 50
      IF((I1*50).GT.NS) I50= NS - M50
      IF(I50.LE.0) GO TO 860
      DO 870  I2=1,I50
      I= J50 + I2
      DO87K=1,NDIM
      DO87L=1,NDIM
      HMZKL= HMZ(K,L,I)
      RR(I2,K,L)=HMZKL+VST(K,I)*VST(L,I)*ELRMAG
      RI(I2,K,L)=    - VST(K,I)*VST(L,I)*ELIMAG
      XR(I2,K,L)= 0.0
      XI(I2,K,L)=0.0
      IF(K.NE.L) GO TO 87
      XR(I2,K,K)= 1.0
      RR(I2,K,K)= RR(I2,K,K) - E
      RI(I2,K,K)= RI(I2,K,K) - EPS
 87   CONTINUE
  870 CONTINUE
       CALL CLSS(9,9,9,9,I50)
      DO 880  I2=1,I50
      I= J50 + I2
      X1= XI(I2,1,1)
      X2= XI(I2,2,2)+XI(I2,3,3)+XI(I2,4,4)
      X3=XI(I2,5,5)+XI(I2,6,6)+XI(I2,7,7)
      X4=                                 XI(I2,8,8)+XI(I2,9,9)
      PDS= PDS +      (X1)*WEIGHT(I)
      PDP= PDP +      (X2)*WEIGHT(I)
      PDD1=PDD1+      (X3)*WEIGHT(I)
      PDD2=PDD2+      (X4)*WEIGHT(I)
  880 CONTINUE
  860 CONTINUE
      ROH= -GI/PI
      PDS= PDS/(PI*TOTVOL)
      PDP= PDP/(PI*TOTVOL)
      PDD1=PDD1/(PI*TOTVOL)
      PDD2=PDD2/(PI*TOTVOL)
      ROPD= PDS + PDP + PDD1+PDD2
      RO=ROH+ROPD
      ANUMEL(IXYZ)=ANUMEL(IXYZ)+RO*2.0*DELE
      PRINT1002,IXYZ,CB
      RES(1,IXYZ)= E
      RES(2,IXYZ)= ROH
      RES(3,IXYZ)= PDS
      RES(4,IXYZ)= PDP
      RES(5,IXYZ)= PDD1
      RES(6,IXYZ)= PDD2
      RES(7,IXYZ)= ROPD
      RES(8,IXYZ)= RO
      PRINT 610,E,ROH,PDS,PDP,PDD1,PDD2,ROPD,RO
  610 FORMAT(/ 5X,8F12.6)
      SAGR=SIGR
      SAGI=SIGI
      E=E+DELE
      IF (E.GE.EMAX) GO TO 1234
 9999 CONTINUE
 1234 CONTINUE
      DO 3422  L=1,IXYZ
      EDUM(L)= RES(1,L)
      DUM(L)= RES(8,L)*2.0
      DUMS1(L )=RES(3,L)*2.0
      DUMP1(L )=RES(4,L)*2.0
      DUMD1(L )=RES(5,L)*2.0
      DUMD2(L )=RES(6,L)*2.0
      DUMS2(L )=RES(2,L) *2.0
      DUMP2(L )=0.0
 3422 CONTINUE
      JNUM= IXYZ - 1
      CALL SIMP(EDUM,DUM,ANUMEL,JNUM)
      ANUMEL(1)= 0.0
      ANUMEL(IXYZ)=ANUMEL(IXYZ-1) + 2.0*DELE*RES(8,IXYZ)
      PRINT 6423
 6423 FORMAT(1H1)
      WRITE(6,194)
      WRITE(20,194)
  194 FORMAT(2X,"ENERGY    Hydrogen-s  METAL-s  METAL-p METAL-t2g METAL
     &-eg MET-TOT-d TOTAL-DOS ELECTRONS"/)
      DO 3425  J=1,IXYZ
      WRITE (20,612) (RES(I,J),I=1,8),ANUMEL(J)
 612  FORMAT(9F10.5)
      PRINT 611,(RES(I,J),I=1,8),ANUMEL(J)
  611 FORMAT (5X,F10.4,10X,9F12.5)
 3425 CONTINUE
      MCOUNT=0
      DO 4080 L=1,IXYZ
      IF(ANUMEL(L).GT.NUELEC) GO TO 178
      GO TO 4080
  178 IF(MCOUNT .NE. 0) GO TO 4080
      MCOUNT=L
 4080 CONTINUE
C     LAGRANGIAN INTERPOLATION OF THE FERMI LEVEL
      MC=MCOUNT
      MCM=MC-1
      S=NUELEC
      EFL=INTERP(S,ANUMEL   ,EDUM(1) ,MCM,2)
      DNORFL=INTERP(S,ANUMEL   ,DUM (1)  ,MCM,2)/2.0
      WRITE(6,841)
  841 FORMAT(//65X,11H (PER SPIN)  )
      DENSFL(1)=INTERP(S,ANUMEL   ,DUMS1(1),MCM,2)/2.0
      DENSFL(2)=INTERP(S,ANUMEL   ,DUMP1(1),MCM,2)/2.0
      DENSFL(3)=INTERP(S,ANUMEL   ,DUMD1(1),MCM,2)/2.0
      DENSFL(4)=INTERP(S, ANUMEL  ,DUMD2(1),MCM,2)/2.0
      DENSFL(5)=INTERP(S,ANUMEL   ,DUMS2(1) ,MCM,2)/2.0
      DENSFL(6)=INTERP(S,ANUMEL   ,DUMP2(1) ,MCM,2)/2.0
      WRITE(6,193)
      WRITE(20,193)
  193 FORMAT(1X,12HFERMI ENERGY,3X,9HELECTRONS,3X,9HTOTAL DOS,7X,1HS,7X,
     &1HP,7X,4HDT2G,7X,3HDEG,7X,1HS,6X,1HP //)
      WRITE(6,839) EFL,NUELEC,DNORFL,(DENSFL(I),I=1,6)
      WRITE(20,839) EFL,NUELEC,DNORFL,(DENSFL(I),I=1,6)
  839  FORMAT(2F10.5   ,3X,7F10.5//)
      STOP
      END
      SUBROUTINE BZONE(KK)
C  DIVIDES THE IRREDUCIBLE 1/48TH OF THE BRILLIOUIN
C  ZONE OF A CUBIC CRYSTAL INTO A MESH OF BOXES.
C     KK=DETERMINES MESH SIZE
C     NSFB=1,2,3 FOR SIMPLE CUBIC,FCC,AND BCC, RESPECTIVELY.
C     IMAX=MAXIMUM VALUE OF RUNNING INDEX
C     IMIN=MINIMUM VALUE OF RUNNING INDEX
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Q(3)
      DIMENSION WEIGHT( 5300),QQ (5300,3)
      COMMON/B/QQ,WEIGHT,TOTVOL,NS
  111 FORMAT(///'  (NSFB,KK,IMIN,IMAX)=',10I4)
  101 FORMAT(//)
  701 FORMAT('  NS=',I5)
      IMAX=-1
      NSFB=2
      IMIN=1
C*********************************************************************
      NS = 0
C  NS IS TO BE THE MESH POINT SEQUENCE NUMBER
C     BREAK UP IRREDUCIBLE SECTOR OF BZ.
      GO TO (230,235,240),NSFB
  230 JIMAX = KK
      PP = 0.5
      GO TO 250
  235 JIMAX = 4*KK
      PP = 1.0
      GO TO 250
  240 JIMAX = 2*KK
      PP = 1.0
  250 CUBE = PP/JIMAX
      IF(IMAX)260,260,270
  260 IMAX = JIMAX
  270 IF(IMIN)280,280,290
  280 IMIN = 3
  290 PRINT 111, NSFB,KK,IMIN,IMAX
C  BRILLOUIN ZONE NOW BROKEN UP INTO THREE PARTS (KM = 1,3)
      TOTVOL=0.0D0
      DO 800 KM = 1,3
      AHALF = CUBE/2.0
      VOLUME = 8.0*AHALF**3
      ASQ = AHALF**2
C**  AHALF IS HALF THE LENGTH OF A LITTLE CUBE EDGE  .
      DO 700 I = IMIN,IMAX
      GO TO (410,415,420),NSFB
  410 JMAX = I
      GO TO 430
  415 JMAX = 3*KK+0.5001-ABS (3*KK+0.5-I)
      KFCC = 6*KK + 1
      GO TO 430
  420 JMAX = KK+0.5001-ABS (KK+0.5-I)
  430 DO 700 J=1,JMAX
      DO 700 K=1,J
      GO TO (450,440,450),NSFB
  440 IF(I+J+K-KFCC) 450,450,700
  450 Q(1) = (I-0.5)*CUBE
      Q(2) = (J-0.5)*CUBE
      Q(3) = (K-0.5)*CUBE
C  THE *LOGICAL IF* FORM OF THE STATEMENT(S) WHICH FOLLOW(S), IS
C*    IF(JMAX.NE.J.AND.J.NE.K) 490,460
      IF((JMAX-J)*(J-K)) 490,460,490
  460 IF(K-JMAX) 480,470,470
  470 U=1.0
      GO TO 500
  480 U = 3.0
      GO TO 500
  490 U = 6.0
  500 NS = NS + 1
C******************************************************************
      WEIGHT(NS)=U*VOLUME
      TOTVOL=TOTVOL+WEIGHT(NS)
      QQ(NS,1)=Q(1)
      QQ(NS,2)=Q(2)
      QQ(NS,3)=Q(3)
C*********************************************************************
  700 CONTINUE
      PRINT 701, NS
      PRINT 101
      KK = 3*KK
      CUBE = CUBE/3.0
      IF(IMIN-1) 900,900,720
  720 CONTINUE
      IMAX = (IMIN-1)*3
      GO TO (760,740,800), KM
  740 IMIN = 1
      GO TO 800
  760 IMIN = 4
  800 CONTINUE
  900 CONTINUE
      RETURN
      END
      SUBROUTINE CLSS(N,M,IA,IB,NMAT)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /A/ AR(50,9,9),AI(50,9,9),BR(50,9,9),BI(50,9,9)
C     DIMENSION AR(50,9,9),AI(50,9,9),BR(50,9,9),BI(50,9,9),X(50),T(50)
      DIMENSION X(50),T(50)
      DIMENSION L(50),SR1(50),SI1(50),SR2(50),SI2(50),VR(50),VI(50)
      DIMENSION HR(50),HI(50)
      ID=1
      IF(N.GT.IA.OR.N.GT.IB.OR.N.LE.0.OR.M.LE.0) GO TO 17
      DO 11 I=1,N
      IM1=I-1
      DO 110 II=1,NMAT
      TT=AR(II,I,I)**2+AI(II,I,I)**2
      T(II)=SQRT(TT)
  110 CONTINUE
      IF(I.EQ.N) GO TO 130
      DO 109 II=1,NMAT
  109 L(II)=I
      IP1=I+1
      DO 1 J=IP1,N
      DO 111 II=1,NMAT
      XX=AR(II,J,I)**2+AI(II,J,I)**2
      X(II)=SQRT(XX)
      IF(X(II).LE.T(II)) GO TO 111
      T(II)=X(II)
      L(II)=J
  111 CONTINUE
    1 CONTINUE
      DO 112 II=1,NMAT
      IF(T(II).EQ.0.0) GO TO 15
      IF(T(II).LT.1.0E-15) PRINT 80
  112 CONTINUE
   80 FORMAT('  SYSTEM NEAR SINGULAR --- CALCULATION CONTINUING')
      DO 113 II=1,NMAT
      LL=L(II)
      IF(LL.EQ.I) GO TO 4
      DO 2 J=1,N
      TEMPR=AR(II,I,J)
      TEMPI=AI(II,I,J)
      AR(II,I,J)=AR(II,LL,J)
      AI(II,I,J)=AI(II,LL,J)
      AR(II,LL,J)=TEMPR
      AI(II,LL,J)=TEMPI
    2 CONTINUE
      DO 3 J=1,M
      TEMPR=BR(II,I,J)
      TEMPI=BI(II,I,J)
      BR(II,I,J)=BR(II,LL,J)
      BI(II,I,J)=BI(II,LL,J)
      BR(II,LL,J)=TEMPR
      BI(II,LL,J)=TEMPI
    3 CONTINUE
    4 CONTINUE
  113 CONTINUE
  130 CONTINUE
      DO 114 II=1,NMAT
      SR1(II)=AR(II,I,I)**2+AI(II,I,I)**2
  114 CONTINUE
      DO 115 II=1,NMAT
      VR(II)=AR(II,I,I)/SR1(II)
      VI(II)=AI(II,I,I)/SR1(II)
  115 CONTINUE
      IF(I.EQ.N) GO TO 9
      DO 8 J=IP1,N
      DO 116 II=1,NMAT
      SR1(II)=0.0
      SI1(II)=0.0
      SR2(II)=0.0
      SI2(II)=0.0
  116 CONTINUE
      IF(IM1.EQ.0) GO TO 6
      DO 5 K=1,IM1
      DO 5 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,I,K)*AR(II,K,J)-AI(II,I,K)*AI(II,K,J)
      SI1(II)=SI1(II)+AR(II,I,K)*AI(II,K,J)+AR(II,K,J)*AI(II,I,K)
    5 CONTINUE
    6 CONTINUE
      DO 117 II=1,NMAT
      HR(II)=AR(II,I,J)-SR1(II)
      HI(II)=AI(II,I,J)-SI1(II)
  117 CONTINUE
      DO 118 II=1,NMAT
      AR(II,I,J)=HR(II)*VR(II)+HI(II)*VI(II)
      AI(II,I,J)=HI(II)*VR(II)-HR(II)*VI(II)
  118 CONTINUE
      DO 7 K=1,I
      DO 7 II=1,NMAT
      SR2(II)=SR2(II)+AR(II,J,K)*AR(II,K,IP1)-AI(II,J,K)*AI(II,K,IP1)
      SI2(II)=SI2(II)+AR(II,J,K)*AI(II,K,IP1)+AI(II,J,K)*AR(II,K,IP1)
    7 CONTINUE
      DO 119 II=1,NMAT
      AR(II,J,IP1) = AR(II,J,IP1)-SR2(II)
      AI(II,J,IP1) = AI(II,J,IP1)-SI2(II)
  119 CONTINUE
    8 CONTINUE
    9 CONTINUE
      DO 120 II=1,NMAT
      IF(T(II).EQ.0.0) GO TO 15
  120 CONTINUE
      DO 11 J=1,M
      DO 121 II=1,NMAT
      SR1(II)=0.0
  121 SI1(II)=0.0
      IF(IM1.EQ.0) GO TO 21
      DO 10 K=1,IM1
      DO 10 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,I,K)*BR(II,K,J)-AI(II,I,K)*BI(II,K,J)
      SI1(II)=SI1(II)+AI(II,I,K)*BR(II,K,J)+AR(II,I,K)*BI(II,K,J)
   10 CONTINUE
   21 CONTINUE
      DO 122 II=1,NMAT
      HR(II)=BR(II,I,J)-SR1(II)
      HI(II)=BI(II,I,J)-SI1(II)
  122 CONTINUE
      DO 123 II=1,NMAT
      BR(II,I,J)=HR(II)*VR(II)+HI(II)*VI(II)
      BI(II,I,J)=HI(II)*VR(II)-HR(II)*VI(II)
  123 CONTINUE
   11 CONTINUE
      IF(N.EQ.1) RETURN
      NM1=N-1
      DO 13 I=1,M
      DO 13 J=1,NM1
      NMJ=N-J
      DO 124 II=1,NMAT
      SR1(II)=0.0
  124 SI1(II)=0.0
      NMJP1=NMJ+1
      DO 12 K=NMJP1,N
      DO 12 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,NMJ,K)*BR(II,K,I)-AI(II,NMJ,K)*BI(II,K,I)
      SI1(II)=SI1(II)+AR(II,NMJ,K)*BI(II,K,I)+AI(II,NMJ,K)*BR(II,K,I)
   12 CONTINUE
      DO 125 II=1,NMAT
      BR(II,NMJ,I)=BR(II,NMJ,I)-SR1(II)
      BI(II,NMJ,I)=BI(II,NMJ,I)-SI1(II)
  125 CONTINUE
   13 CONTINUE
      RETURN
   15 ID=2
   17 PRINT 85
   85 FORMAT(' DIMENSIONING PROBLEM IN CLSS')
      RETURN
      END
      SUBROUTINE SIMP(XX,FX,AX,NX)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XX(4000),FX(4000),AX(4000)
      DELX= XX(2) - XX(1)
      AX(1)= 0.0
      DO 10  IX=2,NX,2
      IF(NX-IX)2,3,2
   2  AX(IX)= DELX*(5.0*FX(IX-1)+8.0*FX(IX)-FX(IX+1))/12.0+AX(IX-1)
      AX(IX+1)=DELX*(FX(IX-1)+4.0*FX(IX)+FX(IX+1))/3.0+AX(IX-1)
   10 CONTINUE
      GO TO 4
    3 AX(NX)=DELX*(-FX(NX-2)+8.0*FX(NX-1)+5.0*FX(NX))/12.0+AX(NX-1)
    4 RETURN
      END
      REAL*8 FUNCTION INTERP   (XX,X,F,J1,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION   X(1),F(1)
      FX=0.
      ISTART=J1-N+N/2+1
      J2=ISTART+N-1
      DO 10 J=ISTART,J2
      P=F(J)
      DO 5 I=ISTART,J2
      IF (I.EQ.J) GO TO 5
      P=P*(XX-X(I))/(X(J)-X(I))
    5 CONTINUE
   10 FX=FX+P
      INTERP=FX
      RETURN
      END
      SUBROUTINE MATS(X1,X2,X3,WW,PAR,V,MAXM1,HYD)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION H(10,10),PAR(60)
      DIMENSION WW(9,9),V(9)
      YY=3.1415926536
      MAX=MAXM1+1
      A1 =PAR(1)
      A6 =PAR(2)
      A14 =PAR(3)
      A19 =PAR(4)
      A2 =PAR(5)
      A3 =PAR(6)
      A4 =PAR(7)
      A5=PAR(8)
      A7=PAR(9)
      A8=PAR(10)
      A9=PAR(11)
      A10=PAR(12)
      A11=PAR(13)
      A12=PAR(14)
      A13=PAR(15)
      A15=PAR(16)
      A16=PAR(17)
      A17=PAR(18)
      A18=PAR(19)
      A20=PAR(20)
      A21=PAR(21)
      B1=PAR(22)
      B2=PAR(23)
      B3=PAR(24)
      B4=PAR(25)
      B5=PAR(26)
      B6=PAR(27)
      B7=PAR(28)
      B8=PAR(29)
      B9=PAR(30)
      B10=PAR(31)
      B11=PAR(32)
      C1=PAR(33)
      C2=PAR(34)
      C3=PAR(35)
      C6=PAR(36)                                                        
      C7=PAR(37)                                                        
      C8=PAR(38)                                                        
        C9=PAR(39)                                                      
        EE=PAR(40)                                                      
        EE2=PAR(41)                                                      
        E4=PAR(42)                                                      
        E5=PAR(43)                                                      
        D1=PAR(44)                                                      
        D2=PAR(45)                                                      
        D3=PAR(46)                                                      
        D4=PAR(47)                                                      
        D5=PAR(48)                                                      
        D6=PAR(49)                                                      
        D7=PAR(50)                                                      
        D8=PAR(51)                                                      
      F1=PAR(52)
      F2=PAR(53)
      F3=PAR(54)
      F4=PAR(55)
      F5=PAR(56)
      G1=PAR(57)
      G2=PAR(58)
      G3=PAR(59)
      G4=PAR(60)
      SR2=SQRT(2.)
      SR3=SQRT(3.)
      DO9I=1,MAX
      DO9J=1,MAX
 9       H(I,J)=0.0
      X1=YY*X1
      Y1=YY*X2
      Z1=YY*X3
      COSX= COS(X1)
      COSY= COS(Y1)
      COSZ= COS(Z1)
      SINX= SIN(X1)
      SINY= SIN(Y1)
      SINZ= SIN(Z1)
      COS2X=COS(2.*X1)
      COS2Y=COS(2.*Y1)
      COS2Z=COS(2.*Z1)
      SIN2X=SIN(2.*X1)
      SIN2Y=SIN(2.*Y1)
      SIN2Z=SIN(2.*Z1)
      H(1,1)=A1+4.*A2*(COSX*COSY+COSY*COSZ+COSZ*COSX)+2.*B1*(COS2X+
     1COS2Z)
C
C+++++H(1,2),H(1,3),H(1,4) ARE REVERSED IN SIGN SO THAT THE REAL MATRIX
C     EQUIVALENT TO COMPLEX MATRIX
C
      H(1,2)=4.*A3*SINX*(COSY+COSZ)+2.*B2*SIN2X
      H(1,3)=4.*A3*SINY*(COSZ+COSX)+2.*B2*SIN2Y
      H(1,4)=4.*A3*SINZ*(COSX+COSY)+2.*B2*SIN2Z
      H(1,2)=-H(1,2)
      H(1,3)=-H(1,3)
      H(1,4)=-H(1,4)
      H(1,5)=-4.*A4*SINX*SINY
      H(1,6)=-4.*A4*SINY*SINZ
      H(1,7)=-4.*A4*SINZ*SINX
      H(1,8)=2.*SR3*A5*COSZ*(COSY-COSX)+SR3*B3*(COS2X-COS2Y)
      H(1,9)=-2.*A5*(-2.*COSX*COSY+COSY*COSZ+COSZ*COSX)+B3*(-COS2X-COS2Y
     1+2.*COS2Z)
      H(2,2)=A6+4.*A7*COSX*(COSY+COSZ)+4.*A8*COSY*COSZ+2.*B4*COS2X+2.*B5
     1*(COS2Y+COS2Z)
      H(2,3)=-4.*A9*SINX*SINY
      H(2,4)=-4.*A9*SINX*SINZ
      H(2,5)=4.*SINY*(A10*COSX+A11*COSZ)+2.*B6*SIN2Y
      H(2,6)=0.
      H(2,7)=4.*SINZ*(A10*COSX+A11*COSY)+2.*B6*SIN2Z
      H(2,8)=2.*SR3*A12*SINX*(COSY+COSZ)+2.*A13*SINX*(COSY-COSZ)+SR3*B7*
     1SIN2X
      H(2,9)=-2.*A12*SINX*(COSY+COSZ)+2.*SR3*A13*SINX*(COSY-COSZ)-B7*
     1SIN2X
      H(3,3)=A6+4.*A7*COSY*(COSZ+COSX)+4.*A8*COSZ*COSX+2.*B4*COS2Y+
     12.*B5*(COS2Z+COS2X)
      H(3,4)=-4.*A9*SINY*SINZ
      H(3,5)=4.*SINX*(A10*COSY+A11*COSZ)+2.*B6*SIN2X
      H(3,6)=4.*SINZ*(A10*COSY+A11*COSX)+2.*B6*SIN2Z
      H(3,7)=0.
      H(3,8)=-2.*SR3*A12*SINY*(COSZ+COSX)-2.*A13*SINY*(COSX-COSZ)-SR3*B7
     1*SIN2Y
      H(3,9)=-2.*A12*SINY*(COSZ+COSX)-2.*SR3*A13*SINY*(COSZ-COSX)-B7*
     1SIN2Y
      H(4,4)=A6+4.*A7*COSZ*(COSX+COSY)+4.*A8*COSX*COSY+2.*B4*COS2Z+2.*B5
     1*(COS2X+COS2Y)
      H(4,5)=0.
      H(4,6)=4.*SINY*(A10*COSZ+A11*COSX)+2.*B6*SIN2Y
      H(4,7)=4.*SINX*(A10*COSZ+A11*COSY)+2.*B6*SIN2X
      H(4,8)=4.*A13*SINZ*(COSY-COSX)
      H(4,9)=4.*A12*SINZ*(COSX+COSY)+2.*B7*SIN2Z
      H(5,5)=A14+4.*A15*COSX*COSY+4.*A16*COSZ*(COSX+COSY)+2.*B8*(COS2X+
     1COS2Y)+2.*B9*COS2Z
      H(5,6)=-4.*A17*SINX*SINZ
      H(5,7)=-4.*A17*SINY*SINZ
      H(5,8)=0.
      H(5,9)=-4.*A18*SINX*SINY
      H(6,6)=A14+4.*A15*COSY*COSZ+4.*A16*COSX*(COSY+COSZ)+2.*B8*(COS2Z
     1+COS2Y)+2.*B9*COS2X
      H(6,7)=-4.*A17*SINX*SINY
      H(6,8)=-2.*SR3*A18*SINY*SINZ
      H(6,9)=2.*A18*SINY*SINZ
      H(7,7)=A14+4.*A15*COSX*COSZ+4.*A16*COSY*(COSX+COSZ)+2.*B8*(COS2X+
     1COS2Z)+2.*B9*COS2Y
      H(7,8)=2.*SR3*A18*SINX*SINZ
      H(7,9)=2.*A18*SINX*SINZ
      H(8,8)=A19+3.*A20*COSZ*(COSX+COSY)+4.*A21*(COSX*COSY+COSX*COSZ/4.+
     1COSY*COSZ/4.)+(3./2.)*B10*(COS2X+COS2Y)+2.*B11*(COS2X/4.+COS2Y/4.+
     2COS2Z)
      H(8,9)=SR3*COSZ*(COSX-COSY)*(A20-A21)+(SR3/2.)*(COS2Y-COS2X)*(B10-
     1B11)
      H(9,9)=A19+4.*A20*(COSX*COSY+COSX*COSZ/4.+COSY*COSZ/4.)+3.*A21*
     1COSZ*(COSX+COSY)+2.*B10*(COS2X/4.+COS2Y/4.+COS2Z)+(3./2.)*B11*
     2(COS2X+COS2Y)
C     CHANGES TO INCORPORATE 2ND NN OF THE A-B INTERACTIONS
      H(1,10)=2.*D1*(COSX+COSY+COSZ)+8.*F1*COSX*COSY*COSZ
      H(2,10)=2.*D3*SINX+8.*F2*SINX*COSY*COSZ
      H(3,10)=2.*D3*SINY+8.*F2*SINY*COSZ*COSX
      H(4,10)=2.*D3*SINZ+8.*F2*SINZ*COSX*COSY
      H(5,10)=-8.*G1*SINX*SINY*COSZ
      H(6,10)=-8.*G1*COSX*SINY*SINZ
      H(7,10)=-8.*G1*SINX*COSY*SINZ
      H(8,10)=SR3*D7*(COSX-COSY)
      H(9,10)=D7*(-COSX-COSY+2.*COSZ)
      H(10,10) =
     1 C1+4.*C2*(COSX*COSY+COSY*COSZ+COSZ*COSX)+2.*EE*(COS2X+COS2Y
     1+COS2Z)
C   END OF 2ND NN A-B INTERACTIONS FOR S AND P ORBITALS
      DO99J=1,MAX
      DO99I=1,J
 99   H(J,I)=H(I,J)
      DO8I=1,MAXM1
      V(I)=H(I,MAX)
      DO8J=1,MAXM1
 8    WW(I,J)=H(I,J)
      HYD= H(10,10) - C1
      RETURN
      END
